      *>***************************************************************
      *> 
      *> Copyright (C) 1984-2007 Micro Focus (IP) Limited.
      *> 
      *> All rights reserved.  Unpublished, all rights reserved
      *> under copyright law and international treaty.  Use of a
      *> copyright notice is precautionary only and does not imply
      *> publication or disclosure. This software contains confidential
      *> information and trade secrets of Micro Focus International
      *> Ltd, and no part of this program or publication may be
      *> reproduced, transmitted, transcribed, stored in a retrieval
      *> system, or translated into any language or computer language,
      *> in any form or by any means, electronic, mechanical, magnetic,
      *> optical, chemical, manual or otherwise, without the prior
      *> written permission of:
      *> 
      *> Micro Focus International Ltd,
      *> The Lawn, Old Bath Road, Newbury, Berkshire, RG14 1QN, UK.
      *> (01635) 32646
      *> 
      *> RESTRICTED RIGHTS LEGEND
      *> Use, duplication, or disclosure by the Government is subject
      *> to restrictions as set forth in subparagraph (c)(1)(ii) of the
      *> Rights in Technical Data and Computer Software clause at
      *> DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of
      *> Commercial Computer Software - Restricted Rights at
      *> 48 CFR 52.227-19, as applicable.  Contact
      *> Micro Focus Incorporated, 1001 West Maude Avenue, Sunnyvale,
      *> California 94085, USA.
      *> 
      *> Genesis Run Time System (Studio/Server 5.0 Freeze)
      *> 
      *> @(#)mfctf.cpy	11.4
      *> 
      *> Last Modified on 07/01/15 at 16:51:50
      *> 
      *>***************************************************************

      *>***************************************************************
      *>
      *> Consolidated Tracing Facility (CTF)
      *>
      *>***************************************************************

      *>---------------------------------------------------------------
      *> CBL_CTF_ API return codes
      *>---------------------------------------------------------------
       78  78-CTF-RET-SUCCESS                   value 0.
       78  78-CTF-RET-FAILURE                   value -1.
       78  78-CTF-RET-INVALID-TRACE-HANDLE      value 1.
       78  78-CTF-RET-INVALID-TRACE-LEVEL       value 2.
       78  78-CTF-RET-NOT-TRACE-ENABLED         value 3.
       78  78-CTF-RET-NOT-TRACING-LEVEL         value 4.
       78  78-CTF-RET-NOT-ENOUGH-MEMORY         value 5.
       78  78-CTF-RET-OUTPUT-ERROR              value 6.
       78  78-CTF-RET-PROPERTY-NOT-FOUND        value 7.
       78  78-CTF-RET-BUFFER-TOO-SMALL          value 8.
       78  78-CTF-RET-VALUE-NOT-INTEGER         value 9.
       78  78-CTF-RET-EMITTER-NOT-FOUND         value 10.
       78  78-CTF-RET-INVALID-EVENT-HANDLE      value 11.
       78  78-CTF-RET-ZERO-LENGTH-DATA          value 12.
       78  78-CTF-RET-INVALID-PROP-NAME         value 13.
       78  78-CTF-RET-INVALID-COMP-NAME         value 14.
       78  78-CTF-RET-INVALID-EMITTER-NAME      value 15.
       78  78-CTF-RET-INVALID-PROG-NAME         value 16.
       78  78-CTF-RET-CALLBACK-NOT-FOUND        value 17.
       78  78-CTF-RET-CALLBACK-EXISTS           value 18.
       78  78-CTF-RET-NO-SERVER-PROCESS         value 19.
       78  78-CTF-RET-ACCESS-DENIED             value 20.

      *>---------------------------------------------------------------
      *> CBL_CTF_ API control flags
      *>---------------------------------------------------------------
       78  78-DESTFLGS-COMPID-STRING            value h'80000000'.

      *>
      *>  Used by:
      *>
      *>        CBL_CTF_EMITTER
      *>
       78  78-CTF-FLAG-PROG-NAME-NULL-TERM      value h'00000001'.

      *>
      *>  Used by:
      *>
      *>        CBL_CTF_ENABLE
      *>
       78  78-CTF-FLAG-COMP-ENABLE              value h'00000000'.
       78  78-CTF-FLAG-COMP-DISABLE             value h'00000001'.

      *>
      *>  Used by:
      *>
      *>        CBL_CTF_DEST
      *>
       78  78-CTF-FLAG-DEST-ADD                 value h'00000000'.
       78  78-CTF-FLAG-DEST-REMOVE              value h'00000001'.
       78  78-CTF-FLAG-DEST-NOINHERIT           value h'00000002'.

      *>
      *>  Used by:
      *>
      *>        CBL_CTF_COMP_PROPERTY_GET
      *>        CBL_CTF_COMP_PROPERTY_SET
      *>        CBL_CTF_EMITTER_PROPERTY_GET
      *>        CBL_CTF_EMITTER_PROPERTY_SET
      *>
       78  78-CTF-FLAG-PROP-STRING-VALUE        value h'00000000'.
       78  78-CTF-FLAG-PROP-INT-VALUE           value h'00000001'.
       78  78-CTF-FLAG-PROP-NULL-TERM           value h'00000002'.

      *>
      *>  Used by:
      *>
      *>        CBL_CTF_TRACE
      *>
       78  78-CTF-FLAG-TRACE-OUTPUT-FORCE       value h'00001000'.
       78  78-CTF-FLAG-TRACE-ARRAY-DATA         value h'00002000'.

      *>
      *>  Used by:
      *>
      *>        CBL_CTF_DEST
      *>        CBL_CTF_EMITTER
      *>        CBL_CTF_EMITTER_PROPERTY_GET
      *>        CBL_CTF_EMITTER_PROPERTY_SET
      *>
       78  78-CTF-FLAG-EMIT-NAME-NULL-TERM      value h'10000000'.

      *>
      *>  Used by:
      *>
      *>        CBL_CTF_COMP_PROPERTY_GET
      *>        CBL_CTF_COMP_PROPERTY_SET
      *>        CBL_CTF_EMITTER_PROPERTY_GET
      *>        CBL_CTF_EMITTER_PROPERTY_SET
      *>
       78  78-CTF-FLAG-PROP-NAME-NULL-TERM      value h'20000000'.

      *>
      *>  Used by:
      *>
      *>        CBL_CTF_COMP_PROPERTY_GET
      *>        CBL_CTF_COMP_PROPERTY_SET
      *>        CBL_CTF_DEST
      *>        CBL_CTF_ENABLE
      *>        CBL_CTF_LEVEL
      *>        CBL_CTF_TRACE
      *>        CBL_CTF_TRACER_GET
      *>        CBL_CTF_TRACER_LEVEL_GET
      *>
       78  78-CTF-FLAG-COMP-NAME-NULL-TERM      value h'40000000'.
      *>
      *>  Used by:
      *>
      *>        CBL_CTF_COMP_PROPERTY_GET
      *>        CBL_CTF_COMP_PROPERTY_SET
      *>        CBL_CTF_DEST
      *>        CBL_CTF_ENABLE
      *>        CBL_CTF_LEVEL
      *>        CBL_CTF_TRACE
      *>        CBL_CTF_TRACER_LEVEL_GET
      *>
       78  78-CTF-FLAG-COMPID-STRING            value h'80000000'.

      *>---------------------------------------------------------------
      *> Trace levels
      *>---------------------------------------------------------------
       78  78-CTF-FLAG-LEVEL-DEBUG              value 0.
       78  78-CTF-FLAG-LEVEL-INFO               value 1.
       78  78-CTF-FLAG-LEVEL-WARN               value 2.
       78  78-CTF-FLAG-LEVEL-ERROR              value 3.
       78  78-CTF-FLAG-LEVEL-FATAL              value 4.

       78  78-CTF-FLAG-LEVEL-NONE               value h'FFFFFFFF'.

      *>---------------------------------------------------------------
      *> Trace event
      *>---------------------------------------------------------------
       01       cblt-trc-event                  typedef.
         03     cblte-trcevt-version            cblt-x4-comp5.
         03     cblte-trcevt-flags              cblt-x4-comp5.
         03     cblte-trcevt-event-id           cblt-x4-comp5.
         03     cblte-trcevt-level              cblt-x4-comp5.
         03     cblte-trcevt-data-count         cblt-x4-comp5.
         03     cblte-trcevt-event-len          cblt-pointer.
         03     cblte-trcevt-event-type         cblt-pointer.
         03     cblte-trcevt-event-data         cblt-pointer.

      *>
      *> Version types (cblte-trcevt-version)
      *>
       78  78-TRACE-EVENT-VERSION               value 0.

      *>
      *> Control flags (cblte-trcevt-flags)
      *>
       78  78-TRACE-EVENT-FLAGS-NONE            value h'00000000'.

      *>
      *> Trace event types (cblte-trcevt-event-type)
      *>
       78  78-TRACE-EVENT-TYPE-BINARY           value 0.
       78  78-TRACE-EVENT-TYPE-TEXT             value 1.
       78  78-TRACE-EVENT-TYPE-ADDRESS          value 2.
       78  78-TRACE-EVENT-TYPE-COMP5            value 3.
       78  78-TRACE-EVENT-TYPE-COMPX            value 4.
       78  78-TRACE-EVENT-TYPE-UTF8             value 5.
       78  78-TRACE-EVENT-TYPE-COMP5S           value 6.
       78  78-TRACE-EVENT-TYPE-COMPXS           value 7.

      *>---------------------------------------------------------------
      *> Tracer notification callback installation
      *>---------------------------------------------------------------
       01       cblt-trc-notif-install          typedef.
         03     cblte-tni-version               cblt-x4-comp5.
         03     cblte-tni-handle                cblt-x4-comp5.
         03     cblte-tni-callback              cblt-ppointer.

       78  78-TRC-NOTIF-TYPE-PROP-CHANGE        value 0.
       78  78-TRC-NOTIF-TYPE-LEVEL-CHANGE       value 1.

      *>---------------------------------------------------------------
      *> Tracer notification: property change
      *>---------------------------------------------------------------
       01       cblt-trc-notif-prop-change      typedef.
         03     cblte-tnpc-version              cblt-x4-comp5.
         03     cblte-tnpc-flags                cblt-x4-comp5.
         03     cblte-tnpc-namelen              cblt-x4-comp5.
         03     cblte-tnpc-vallen               cblt-x4-comp5.
         03     cblte-tnpc-valint               cblt-x4-comp5.
         03     cblte-tnpc-name                 cblt-pointer.
         03     cblte-tnpc-value                cblt-pointer.

      *>
      *> Version types (cblte-tnpc-version)
      *>
       78  78-PROP-CHANGE-VERSION               value 0.

      *>
      *> Control flags (cblte-tnpc-flags)
      *>
       78  78-PROP-CHANGE-FLAGS-NONE            value h'00000000'.
       78  78-PROP-CHANGE-FLAGS-VAL-INT         value h'00000001'.
